﻿using Infragistics.Controls.Editors;
using Infragistics.Controls.Editors.Primitives;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Globalization;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace PropertyGrid_Sample
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Person p = new Person();
        public MainWindow()
        {
            InitializeComponent();
            property_Grid.SelectedObject = p;
            this.DataContext = p;

            List<Person> ps = new List<Person>();

            ps.Add(new Person() { Age = 20, FirstName = "Test" });

            lvDataBinding.ItemsSource = ps;
        }

        private void changeProperties_Click(object sender, RoutedEventArgs e)
        {
            p.FirstName = "";
        }
    }

    public class StringNotEmptyValidationRule : ValidationRule
    {
        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            var str = value as string;
            if (String.IsNullOrEmpty(str))
                return new ValidationResult(false, "Field cannot be null");

            else
                return new ValidationResult(true, null);
        }
    }

    class AgeValidation : ValidationRule
    {
        public override ValidationResult Validate(object value, System.Globalization.CultureInfo cultureInfo)
        {
            int age;
            Boolean noIllegalChars;
            noIllegalChars = int.TryParse(value.ToString(), out age);

            if (age < 0 || age > 150)
            {
                return new ValidationResult(false, "Age must not be less than 0 or greater than 150.");
            }
            //if (value.ToString().Length < 1)
            //{
            //    return new ValidationResult(false, "Age field cannot be empty");
            //}
            //else if (noIllegalChars == false)
            //{
            //    return new ValidationResult(false, "Illegal Characters");
            //}
            else
            {
                return new ValidationResult(true, null);
            }
        }
    }



    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            return Binding.DoNothing;
        }
        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }




}