﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Controls;
using System.Windows.Media;

namespace PropertyGrid_Sample
{
    public class Person : IDataErrorInfo, INotifyPropertyChanged
    {

        string _firstName;
        //		[Display(Name = "First Name", GroupName = "Information")]
        [Description("This property uses a TextBox as the default editor. This is a very long description. Testing the text wrapping feature!")]
        public string FirstName
        {
            get { return _firstName; }
            set
            {
                if (value.ToString() == "John")
                {
                    throw new Exception("Name cannot be John");
                }
                        _firstName = value;
                NotifyPropertyChanged("FirstName");
            }
        }
        
        int _age;
        [Category("Information")]
        [Description("This property uses the XamNumericInput as the default editor.")]
        public int Age
        {
            get { return _age; }
            set
            {
                _age = value;
                NotifyPropertyChanged("Age");
            }
        }


        public string Error
        {
            get
            {
                return null;
            }
        }

        public string this[string name]
        {
            get
            {
                string result = null;

                if (name == "Age")
                {
                    if (this.Age < 0 || this.Age > 150)
                    {
                        result = "Age must not be less than 0 or greater than 150!!!";
                    }
                }
                return result;
            }
        }

        public void ResetFirstName()
        {
            FirstName = "John";
        }


        public Person()
        {
            FirstName = "Arnold";
            Age = 22;
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void NotifyPropertyChanged(string propertyName)
        {
            var handler = PropertyChanged;
            if (handler != null)
                handler(this, new PropertyChangedEventArgs(propertyName));
        }
    }

   
}
